<?php
namespace ChangeCommerce\Core\Model;

use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Serialize\Serializer\Json;

class OrderWebhookFailure extends AbstractModel
{
    protected function _construct() {
        parent::_construct();
        $this->_init('ChangeCommerce\Core\Model\ResourceModel\OrderWebhookFailure');
    }

    public function saveFailure($step, $hookName, $requestBody, $requestUri, $requestVerb, $requestHeadersJson, $response, $responseStatusCode, $message, $orderId) 
    {
        $data = array('step'=>$step,
        'hook_name'=>$hookName, 
        'request_body'=>$requestBody, 
        'request_uri'=>$requestUri, 
        'request_verb'=>$requestVerb,
        'request_headers_json'=>$requestHeadersJson, 
        'response'=>$response, 
        'response_status_code'=>$responseStatusCode, 
        'message'=>$message, 
        'order_id'=>$orderId);
        $this->setData($data);
        $this->save();
    }
}